#include <vector>
#include <fstream>
#include <cmath>
#include <algorithm>

using namespace std;

#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)

struct Pont
{
	double x, y, szog;
	void szamolSzog()
	{
		szog = atan2(y, x);
	}

	bool operator<(Pont &x)
	{
		return szog < x.szog;
	}
};

double haromszogTerulet(Pont p1, Pont p2, Pont p3)
{
	return (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y);
}

struct Sokszog
{
	int n;
	vector <Pont> pontok;
	void rendezPontok()
	{
		sort(pontok.begin() + 1, pontok.end());
	}
	double terulet()
	{
		double t = 0;
		FOR(i, 2, n - 1) t += haromszogTerulet(pontok[1], pontok[i], pontok[i + 1]);
		return t / 2;
	}
};

ifstream fin("fel4.in");
ofstream fout("fel4.out");

void beolvas(Sokszog &sokszog)
{
	fin >> sokszog.n;
	sokszog.pontok.resize(sokszog.n + 1);
	FOR(i, 1, sokszog.n)
	{
		fin >> sokszog.pontok[i].x >> sokszog.pontok[i].y;
		sokszog.pontok[i].szamolSzog();
	}
}

void kiir(Sokszog &sokszog)
{
	fout << "A pontok rendezve:" << endl;
	FOR(i, 1, sokszog.n)
		fout << sokszog.pontok[i].x << " " << sokszog.pontok[i].y << endl;
	fout << "A sokszog terulete: " << sokszog.terulet();
}

Sokszog sokszog;
void main()
{
	beolvas(sokszog);
	sokszog.rendezPontok();
	kiir(sokszog);
}