uses dos;

const
  BE_ALLOMANY = 'fel1.in';
  KI_ALLOMANY = 'fel1.out';
  NAPOK : array[1..12] of byte =
    (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

type
  Szemely =
  record
        nev : string;
        szul_ev : word;
        szul_ho, szul_nap : byte;
        bet_ev : byte;
        bet_nap : word;
        magassag: byte;
  end;
  SzemelyTomb = array[1..10000] of Szemely;

var
  AKT_EV, AKT_HO, AKT_NAP, HET_NAPJA : word;

function szokoev(ev : word) : boolean;
begin
  szokoev := ((ev mod 4) = 0) and ((ev mod 100) <> 0) or
    ((ev mod 400) = 0);
end;

function szamolNapSorszam(ev : word; honap, nap : byte) : word;
var
  i : byte;
  sorszam : word;
begin
  if szokoev(ev)
  then NAPOK[2] := 28
  else NAPOK[2] := 29;

  sorszam := 0;
  for i := 1 to honap - 1 do inc(sorszam, NAPOK[i]);
  inc(sorszam, nap);
  szamolNapSorszam := sorszam;
end;

procedure szamolEvekNapok(var sz : Szemely);
var akt_sorszam, szul_sorszam : word;
begin
  akt_sorszam := szamolNapSorszam(AKT_EV, AKT_HO, AKT_NAP);
  with sz do
  begin
    if (AKT_HO > szul_ho) or
      (AKT_HO = szul_ho) and (AKT_NAP >= szul_nap)
    then
    begin
      bet_ev := AKT_EV - szul_ev;
      szul_sorszam := szamolNapSorszam(AKT_EV, szul_ho, szul_nap);
      bet_nap := akt_sorszam - szul_sorszam;
    end
    else
    begin
      bet_ev := AKT_EV - szul_ev - 1;
      szul_sorszam := szamolNapSorszam(AKT_EV - 1, szul_ho, szul_nap);
      bet_nap := 365 - szul_sorszam + akt_sorszam;
      if szokoev(AKT_EV - 1)
      then inc(bet_nap);
    end;
  end
end;

procedure beolvas(var n : word; var a : SzemelyTomb);
var
  f : text;
  i : word;
begin
  assign(f, BE_ALLOMANY);
  reset(f);
  readln(f, n);
  for i := 1 to n do
  begin
    with a[i] do
    begin
      readln(f, nev);
      readln(f, szul_ev, szul_ho, szul_nap, magassag);
    end;
    szamolEvekNapok(a[i]);
  end;
  close(f);
end;

procedure osszefesul(var a : SzemelyTomb; bal, kozep, jobb : word; krit : boolean);
var
  masolat : SzemelyTomb;
  i, j, k : word;
  lepBal, felt : boolean;
begin
  for i := bal to jobb do masolat[i] := a[i];
  i := bal;
  j := kozep + 1;
  for k := bal to jobb do
  begin
    if i > kozep
    then lepBal := false
    else
      if j > jobb
      then lepBal := true
      else
      begin
        if krit
        then felt := masolat[i].magassag > masolat[j].magassag
        else felt := (masolat[i].bet_ev < masolat[j].bet_ev) or
          (masolat[i].bet_ev = masolat[j].bet_ev) and
          (masolat[i].bet_nap < masolat[j].bet_nap);
        if felt
        then lepBal := true
        else lepBal := false;
      end;
    if lepBal
    then
    begin
      a[k] := masolat[i];
      inc(i);
    end
    else
    begin
      a[k] := masolat[j];
      inc(j);
    end
  end;
end;

procedure osszefesulesesRendezes(var a : SzemelyTomb; bal, jobb : word; krit : boolean);
var kozep : word;
begin
  if bal < jobb
  then
  begin
    kozep := (bal + jobb) div 2;
    osszefesulesesRendezes(a, bal, kozep, krit);
    osszefesulesesRendezes(a, kozep + 1, jobb, krit);
    osszefesul(a, bal, kozep, jobb, krit);
  end;
end;

procedure kiirMag(var a : SzemelyTomb; n : word);
var
  i : word;
  f : text;
begin
  assign(f, KI_ALLOMANY);
  rewrite(f);
  for i := 1 to n do writeln(f, a[i].nev, ' ', a[i].magassag);
  writeln(f);
  close(f);
end;

procedure kiirEv(var a : SzemelyTomb; n : word);
var
  i : word;
  f : text;
begin
  assign(f, KI_ALLOMANY);
  append(f);
  for i := 1 to n do writeln(f, a[i].nev, ' ', a[i].bet_ev, ' ', a[i].bet_nap);
  close(f);
end;


var
  n : word;
  szemelyek : SzemelyTomb;
begin
  getdate(AKT_EV, AKT_HO, AKT_NAP, HET_NAPJA);
  beolvas(n, szemelyek);
  osszefesulesesRendezes(szemelyek, 1, n, true);
  kiirMag(szemelyek, n);
  osszefesulesesRendezes(szemelyek, 1, n, false);
  kiirEv(szemelyek, n);
end.
