const
  BE_ALLOMANY = 'fel2.in';
  KI_ALLOMANY = 'fel2.out';

type
  Komplex =
  record
    valos, imag, tav : double;
    index : word;
  end;
  KomplexTomb = array[1..10000] of Komplex;

var
  fki : text;

procedure szamolTav(var k : Komplex);
begin
  k.tav := sqrt(sqr(k.valos) + sqr(k.imag));
end;

procedure beolvas(var n : word; var a : KomplexTomb);
var
  f : text;
  i : word;
begin
  assign(f, BE_ALLOMANY);
  reset(f);
  read(f, n);
  for i := 1 to n do
  begin
    with a[i] do
    begin
      read(f, valos, imag);
      index := i;
    end;
    szamolTav(a[i]);
  end;
  close(f);
end;

function osszeg(x, y : Komplex) : Komplex;
var
  s : Komplex;
begin
  s.valos := x.valos + y.valos;
  s.imag := x.imag + y.imag;
  osszeg := s;
end;

function szorzat(x, y : Komplex) : Komplex;
var
  p : Komplex;
begin
  p.valos := x.valos * y.valos - x.imag * y.imag;
  p.imag := x.valos * y.imag + x.imag * y.valos;
  szorzat := p;
end;

function szamolOsszeg(n : word; a : KomplexTomb) : Komplex;
var
  s : Komplex;
  i : word;
begin
  s.valos := 0;
  s.imag := 0;
  for i := 1 to n do s := osszeg(s, a[i]);
  szamolOsszeg := s;
end;

function szamolSzorzat(n : word; a : KomplexTomb) : Komplex;
var
  p : Komplex;
  i : word;
begin
  p.valos := 1;
  p.imag := 0;
  for i := 1 to n do
    p := szorzat(p, a[i]);
  szamolSzorzat := p;
end;

procedure kiirOsszegSzorzat(n : word; a : KomplexTomb);
var s, p : Komplex;
begin
  assign(fki, KI_ALLOMANY);
  rewrite(fki);
  s := szamolOsszeg(n, a);
  p := szamolSzorzat(n, a);
  writeln(fki, 'Osszeg = ', s.valos:1:2, ' + ', s.imag:1:2, 'i');
  writeln(fki, 'Szorzat = ', p.valos:1:2, ' + ', p.imag:1:2, 'i');
end;

procedure osszefesul(var a : KomplexTomb; bal, kozep, jobb : word);
var
  masolat : KomplexTomb;
  i, j, k : word;
  lepBal, felt : boolean;
begin
  for i := bal to jobb do masolat[i] := a[i];
  i := bal;
  j := kozep + 1;
  for k := bal to jobb do
  begin
    if i > kozep
    then lepBal := false
    else
      if j > jobb
      then lepBal := true
      else
      begin
        if masolat[i].tav < masolat[j].tav
        then lepBal := true
        else lepBal := false;
      end;
    if lepBal
    then
    begin
      a[k] := masolat[i];
      inc(i);
    end
    else
    begin
      a[k] := masolat[j];
      inc(j);
    end
  end;
end;

procedure osszefesulesesRendezes(var a : KomplexTomb; bal, jobb : word);
var kozep : word;
begin
  if bal < jobb
  then
  begin
    kozep := (bal + jobb) div 2;
    osszefesulesesRendezes(a, bal, kozep);
    osszefesulesesRendezes(a, kozep + 1, jobb);
    osszefesul(a, bal, kozep, jobb);
  end;
end;

function egyenlo(x, y : double) : boolean;
begin
  egyenlo := abs(x - y) < 0.00000001;
end;

procedure kiirCsoportok(n : word; a : KomplexTomb);
var
  i : word;
  benne : boolean;
begin
  benne := false;
  for i := 2 to n do
  begin
    if egyenlo(a[i].tav, a[i - 1].tav)
    then
      if not benne
      then
      begin
        writeln(fki);
        write(fki, a[i].tav:1:2, ' tavolsagra levo pontok: ', a[i - 1].index, ' ');
        benne := true;
      end
      else
    else benne := false;
    if benne
      then write(fki, a[i].index, ' ');
  end
end;

var
  n : word;
  szamok : KomplexTomb;
begin
  beolvas(n, szamok);
  kiirOsszegSzorzat(n, szamok);
  osszefesulesesRendezes(szamok, 1, n);
  kiirCsoportok(n, szamok);
  close(fki);
end.
